"use strict";

var visit = require(`unist-util-visit`);
var Prism = require(`prismjs`);

module.exports = function (_ref) {
  var markdownAST = _ref.markdownAST;

  visit(markdownAST, `code`, function (node) {
    // (Try to) load languages on demand.
    if (!Prism.languages[node.lang]) {
      try {
        require(`prismjs/components/prism-${ node.lang }.js`);
      } catch (e) {
        // Language wasn't loaded so let's bail.
        return;
      }
    }

    var lang = Prism.languages[node.lang];
    node.data = {
      hChildren: [{ type: `raw`, value: Prism.highlight(node.value, lang) }]
    };
  });
};